#define	INITGUID
#include <windows.h>
#include <vfw.h>
#include "pluginmain.h"

//---------------------------------------------------------------------------
DEFINE_GUID(RBAAVICAPTURE,0xF583BDEC,0x86F8,0x4E20,0xAE,0xE6,0xD7,0x45,0x6A,0x40,0x3D,0xCC);
//---------------------------------------------------------------------------
HINSTANCE hInstance;
PAVIFILE pFile;
PAVISTREAM pVideoStream;
DWORD nVideoSamples;
//---------------------------------------------------------------------------
BOOL StartCapture();
BOOL AddVideoFrame(unsigned	short *src);
//---------------------------------------------------------------------------
int	WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long	reason,	void *)
{
	if(reason == DLL_PROCESS_ATTACH){
	   hInstance = hinst;
	   pFile = NULL;
	   pVideoStream	= NULL;
   	}
   	return 1;
}
//---------------------------------------------------------------------------
extern "C" DWORD __declspec(dllexport) WINAPI GetInfoFunc(LPPLUGININFO p)
{
	p->wType = PIT_DYNAMIC|PIT_VIDEO|PIT_NOMODIFY;
    if(p->pszText !=	NULL){
		switch(LOWORD(p->dwLanguageID)){
			default:
				lstrcpyn((LPSTR)p->pszText,"AviCapture",p->cchTextMax);
		   	break;
	   	}
   	}
   	*(&p->guidID) = *(&RBAAVICAPTURE);
   	return 1;
}
//---------------------------------------------------------------------------
extern "C" BOOL	__declspec(dllexport) WINAPI SetInfoFunc(LPPLUGININFO p)
{
	if(p ==	NULL)
	   return FALSE;
   	if(PLUGINISRUN(p))
	   StartCapture();
   	return TRUE;
}
//---------------------------------------------------------------------------
extern "C" BOOL	__declspec(dllexport) WINAPI RunFunc(WORD index,unsigned short *src,unsigned short*dst)
{
   	return AddVideoFrame(src);
}
//---------------------------------------------------------------------------
extern "C" BOOL	__declspec(dllexport) WINAPI ResetFunc()
{
   	if(pVideoStream != NULL)
		AVIStreamRelease(pVideoStream);
   	pVideoStream	= NULL;
   	if(pFile	!= NULL)
	   	AVIFileRelease(pFile);
   	pFile = NULL;
   	nVideoSamples = 0;
   	AVIFileExit();
   	return TRUE;
}
//---------------------------------------------------------------------------
extern "C" BOOL	__declspec(dllexport) WINAPI DeleteFunc()
{
   	return ResetFunc();
}
//---------------------------------------------------------------------------
BOOL AddVideoFrame(unsigned	short *src)
{
   	LONG	lFrames;

   	if(pVideoStream == NULL || src == NULL)
		return FALSE;
   	AVIStreamWrite(pVideoStream,nVideoSamples,1,src,240*160*sizeof(unsigned short),0,&lFrames,NULL);
   	nVideoSamples +=	lFrames;
   	return TRUE;
}
//---------------------------------------------------------------------------
BOOL StartCapture()
{
	OPENFILENAME ofn = {0};
	AVISTREAMINFO avisi	= {0};
	BITMAPINFOHEADER bminfo	= {0};
	char szNameFile[MAX_PATH];
	int	res;

	ResetFunc();
	*((long	*)szNameFile) =	0;
	ofn.lStructSize	= sizeof(OPENFILENAME);
	ofn.hInstance =	hInstance;
	ofn.lpstrFilter	= "AVI Files (*.avi)\0*.avi\0\0\0";
	ofn.lpstrFile =	szNameFile;
	ofn.Flags =	OFN_CREATEPROMPT|OFN_OVERWRITEPROMPT;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrDefExt	= "avi";
	if(!GetSaveFileName(&ofn))
		return FALSE;
	AVIFileInit();

	res = AVIFileOpen(&pFile,szNameFile,OF_CREATE|OF_WRITE,NULL);
	if(res)
		return FALSE;
	avisi.dwScale =	16;
	avisi.dwRate = 1000;
	avisi.fccType =	streamtypeVIDEO;
	avisi.rcFrame.right	= 240;
	avisi.rcFrame.bottom = 160;
	avisi.dwQuality	= (DWORD)ICQUALITY_DEFAULT;

	res = AVIFileCreateStream(pFile,&pVideoStream,&avisi);
	if(res)
		return FALSE;
	bminfo.biSize		 = sizeof(BITMAPINFOHEADER);
	bminfo.biBitCount	  =	16;
	bminfo.biWidth		  =	240;
	bminfo.biHeight	  =	-160;
	bminfo.biPlanes	  =	1;
	bminfo.biCompression =	BI_RGB;

	res	= AVIStreamSetFormat(pVideoStream,0,&bminfo,sizeof(BITMAPINFOHEADER));
	nVideoSamples =	0;

	return	(BOOL)(res ? FALSE : TRUE);
}






